// Trellis platform tools module header
#ifndef _TRELLIS_H_
#define _TRELLIS_H_


#include <stdio.h>
#include "controls.h"
#include "colors.h"

// When setting pixel use GRB

void initializeTrellis(const char* bus, unsigned char deviceAddress);
void setPixelColor(int index, color color);
bool compareColors(color c1, color c2);
// Change naming
void pixelOn();
void pixelOff(int index);
void allPixelsOff();
// startIndex - index of the first pixel to display the color
void displayColorsOnDiagonal(const color* colors, size_t len, int startIndex);
void blinkAtIndeces(int times, int delay, int* indeces, size_t len, color c);
void fadingBlinkOnTwoIndeces(int delay, int delta, int* indeces1,
                                int* indeces2, int len1, int len2, color c1, color c2);
void blinkAtIndex(int times, int delay, int index, color c);
void setColorForPixels(int* indeces, size_t len, color c);
void displayInStepWithDelay(int step, int delay, int* indeces, size_t len, color c);
int getNextPushedButtonIndex(int* exit_sig);
void startBlinkingIndefinitely(int delay, int index, color c);
void stopBlinkingIndefinitely();
void blinkAllPixels(int times, int delay, color c);
// This function should not be there, but for convenience is
// it's better to move it to game.c
void destroyTrellis();


#endif
