// I2C Wrapper Tool module

#include <controls.h>

#include "smbus.h"


#define CONFIG_PIN_COMMAND "config-pin"
#define I2C2_SCL_PIN "P9_19"
#define I2C2_SDA_PIN "P9_20"
#define I2C_MODE "i2c"
#define SPACE " "

unsigned int device;


static void configureI2CPins() {
    system(CONFIG_PIN_COMMAND SPACE I2C2_SDA_PIN SPACE I2C_MODE);
    system(CONFIG_PIN_COMMAND SPACE I2C2_SCL_PIN SPACE I2C_MODE);
    sleepMS(500);
}

int i2cWrite(void* buffer, size_t size) {
    return writeTo(device, buffer, size);
}

int i2cRead(void* buffer, size_t size) {
    int bytesRead = readFrom(device, buffer, size);
    return bytesRead;
}

void initializeI2C(const char* bus, unsigned int deviceAddress) {
    configureI2CPins();
    initializeSMBus(bus);
    device = deviceAddress;
}

void destroyI2C() {
    closeSMBus();
}
