// Keypad control wrapper module

#include "seesaw.h"
#include "keypad.h"


#define KEYPAD_BASE 0x10
#define KEYPAD_FIFO 0x10
#define KEYPAD_EVENT 0x01
#define KEYPAD_EVENT_COUNT 0x04
#define DEFAULT_KEYPAD_SIZE 16


static int getEventKey(int val) {
    return val / 4 * 8 + val % 4;
}

void setEventForPixel(int index, unsigned char edge, bool enable) {
    unsigned char eventKey = getEventKey(index);
    // Can't really turn it off with OR(|)
    // I think need to toggle last bit of edge ot 0 or 1
    // depending on enable
    ssWrite(4,KEYPAD_BASE, KEYPAD_EVENT, eventKey, edge | enable);
}


void setEventForAll(unsigned char edge, bool enable) {
    for (int i = 0; i < DEFAULT_KEYPAD_SIZE; i++) {
        setEventForPixel(i, edge, enable);
    }
}

int readEventCount() {
    int count = ssRead8(KEYPAD_BASE, KEYPAD_EVENT_COUNT);
    return count;
}

int readBoard(unsigned char* buf, size_t n) {
    int bytesRead = ssRead(KEYPAD_BASE, KEYPAD_FIFO, buf, n);
    return bytesRead;
}
